cp={}
cp.idir="gfx/customprojectile/"
function init(a,b)
local array = {}
for i = 1, a do
array[i] = b
end
return array
end
cp.type=init(32,1)
cp.fly=init(32,{})
cp.img=init(32,{})
cp.x=init(32,{})
cp.y=init(32,{})
cp.dir=init(32,{})
for all=1,32 do
	cp.fly[all]=init(5,false)
	cp.img[all]=init(5,"")
	cp.x[all]=init(5,0)
	cp.y[all]=init(5,0)
	cp.dir[all]=init(5,0)
end
cp.mpage=init(32,0)
cp.projectile={
	[1]={
		name="Fire";
		imgpath="gfx/customprojectile/fire.png";
		speed=5;
		damage=75;
		cost=100;
	};
	[2]={
		name="Water";
		imgpath="gfx/customprojectile/water.png";
		speed=8;
		damage=25;
		cost=75;
	};
	[3]={
		name="Earth";
		imgpath="gfx/customprojectile/nature.png";
		speed=13;
		damage=10;
		cost=50;
	};
	[4]={
		name="Rock";
		imgpath="gfx/customprojectile/rock.png";
		speed=3;
		damage=75;
		cost=125;
	};
	[5]={
		name="Lightning";
		imgpath="gfx/customprojectile/lightning.png";
		speed=19;
		damage=35;
		cost=200;
	};
	[6]={
		name="Spirit";
		imgpath="gfx/customprojectile/spirit.png";
		speed=4;
		damage=150;
		cost=250;
	};
	[7]={
		name="Haunted Spirit";
		imgpath="gfx/customprojectile/spirit.png";
		speed=3;
		damage=350;
		cost=500;
	};
	[8]={
		name="Paranormal Spirit";
		imgpath="gfx/customprojectile/spirit.png";
		speed=1;
		damage=650;
		cost=1000;
	};
}

addhook("attack","cp.atk")
function cp.atk(id)
	for ps=1,5 do
		if cp.fly[id][ps]==false then
			if player(id,"weapontype")==50 then	
				local type=cp.type[id]
				cp.img[id][ps]=image(cp.projectile[type].imgpath,player(id,"x"),player(id,"y"),1)
				cp.fly[id][ps]=true
				cp.x[id][ps]=player(id,"x")
				cp.y[id][ps]=player(id,"y")
				cp.dir[id][ps]=player(id,"rot")+math.random(-1,1)
				if cp.dir[id][ps]<0 then cp.dir[id][ps]=cp.dir[id][ps]+360 end
				local mt=cp.projectile[type].cost
				parse("setmoney "..id.." "..player(id,"money")-mt)
				break
			end
		end
	end
end

addhook("always","cp.alw")
function cp.alw()
	ist=false
	for id=1,32 do
		for id2=1,32 do
			for ps=1,5 do
				if cp.fly[id][ps]==true and player(id,"exists") and player(id2,"exists") and id~=id2 and player(id,"team")~=player(id2,"team") and cp.fly[id][ps]==true and player(id2,"health")>0 then
					local dist=math.sqrt((player(id2,"x")-cp.x[id][ps])^2+(player(id2,"y")-cp.y[id][ps])^2)
					local type=cp.type[id]
					local inrad=math.rad(cp.dir[id][ps]-180)
					local s,c=cp.x[id][ps]-math.sin(inrad)*cp.projectile[type].speed/8,cp.y[id][ps]+math.cos(inrad)*cp.projectile[type].speed/8
					cp.x[id][ps]=s
					cp.y[id][ps]=c
					if (math.random(1,100))<11 then parse('effect "smoke" '..cp.x[id][ps]..' '..cp.y[id][ps]..' 1 0.5') end
					local tx,ty=math.floor(cp.x[id][ps]/32),math.floor(cp.y[id][ps]/32)
					if tile(tx,ty,"wall") then
						freeimage(cp.img[id][ps])
						cp.fly[id][ps]=false
					else
						imagepos(cp.img[id][ps],s,c,cp.dir[id][ps])
						if dist < 15 and cp.fly[id][ps] then
							local dmg=cp.projectile[type].damage
							local wpnn=cp.projectile[type].name
							if player(id2,"health")>dmg then
								parse("sethealth "..id2.." "..player(id2,"health")-dmg)
							else
								parse('customkill '..id..' "'..wpnn..'" '..id2)
							end
							freeimage(cp.img[id][ps])
							cp.fly[id][ps]=false
							ist=true
						end
					end					
				end
			end
			if ist then break end
		end
	end
end

addhook("serveraction","cp.act")
function cp.act(id,action)
	if action==1 then
		local p=cp.mpage[id]
		for sid=math.ceil(p*6)+1,math.ceil(p*6)+6 do
			if cp.projectile[sid]==nil then
				cp.projectile[sid]={name="";
						    cost="";
						   }
			end
		end
		menu(id,"Set Projectile Page "..(p+1).." / "..math.ceil(#cp.projectile/6)..","..cp.projectile[math.ceil(p*6)+1].name.."|"..cp.projectile[math.floor(p*6)+1].cost..","..cp.projectile[math.floor(p*6)+2].name.."|"..cp.projectile[math.floor(p*6)+2].cost..","..cp.projectile[math.floor(p*6)+3].name.."|"..cp.projectile[math.floor(p*6)+3].cost..","..cp.projectile[math.floor(p*6)+4].name.."|"..cp.projectile[math.floor(p*6)+4].cost..","..cp.projectile[math.floor(p*6)+5].name.."|"..cp.projectile[math.floor(p*6)+5].cost..","..cp.projectile[math.floor(p*6)+6].name.."|"..cp.projectile[math.floor(p*6)+6].cost..",,Previous,Next")
	end
end

addhook("menu","cp.menu")
function cp.menu(id,title,button)
	local p=cp.mpage[id]
	if title=="Set Projectile Page "..(p+1).." / "..math.ceil(#cp.projectile/6) then
		if button<=6 and button>=1 then
			cp.type[id]=math.ceil(p*6)+button	
			local t=cp.type[id]
			msg("Your projectile is now "..cp.projectile[t].name.." with "..cp.projectile[t].cost.."$ per shoot")
		end
		if button==8 then
			if p~=0 then
				cp.mpage[id]=cp.mpage[id]-1
				local p=cp.mpage[id]
				for sid=math.ceil(p*6)+1,math.ceil(p*6)+6 do
					if cp.projectile[sid]==nil then
						cp.projectile[sid]={name="";
								    cost="";
								   }
					end
				end
				menu(id,"Set Projectile Page "..(p+1).." / "..math.ceil(#cp.projectile/6)..","..cp.projectile[math.ceil(p*6)+1].name.."|"..cp.projectile[math.floor(p*6)+1].cost..","..cp.projectile[math.floor(p*6)+2].name.."|"..cp.projectile[math.floor(p*6)+2].cost..","..cp.projectile[math.floor(p*6)+3].name.."|"..cp.projectile[math.floor(p*6)+3].cost..","..cp.projectile[math.floor(p*6)+4].name.."|"..cp.projectile[math.floor(p*6)+4].cost..","..cp.projectile[math.floor(p*6)+5].name.."|"..cp.projectile[math.floor(p*6)+5].cost..","..cp.projectile[math.floor(p*6)+6].name.."|"..cp.projectile[math.floor(p*6)+6].cost..",,Previous,Next")
			else
				menu(id,"Set Projectile Page "..(p+1).." / "..math.ceil(#cp.projectile/6)..","..cp.projectile[math.ceil(p*6)+1].name.."|"..cp.projectile[math.floor(p*6)+1].cost..","..cp.projectile[math.floor(p*6)+2].name.."|"..cp.projectile[math.floor(p*6)+2].cost..","..cp.projectile[math.floor(p*6)+3].name.."|"..cp.projectile[math.floor(p*6)+3].cost..","..cp.projectile[math.floor(p*6)+4].name.."|"..cp.projectile[math.floor(p*6)+4].cost..","..cp.projectile[math.floor(p*6)+5].name.."|"..cp.projectile[math.floor(p*6)+5].cost..","..cp.projectile[math.floor(p*6)+6].name.."|"..cp.projectile[math.floor(p*6)+6].cost..",,Previous,Next")
			end
		end
		if button==9 then
			if p~=math.ceil(#cp.projectile/6)-1 then
				cp.mpage[id]=cp.mpage[id]+1
				local p=cp.mpage[id]
				for sid=math.ceil(p*6)+1,math.ceil(p*6)+6 do
					if cp.projectile[sid]==nil then
						cp.projectile[sid]={name="";
								    cost="";
								   }
					end
				end
				menu(id,"Set Projectile Page "..(p+1).." / "..math.ceil(#cp.projectile/6)..","..cp.projectile[math.ceil(p*6)+1].name.."|"..cp.projectile[math.floor(p*6)+1].cost..","..cp.projectile[math.floor(p*6)+2].name.."|"..cp.projectile[math.floor(p*6)+2].cost..","..cp.projectile[math.floor(p*6)+3].name.."|"..cp.projectile[math.floor(p*6)+3].cost..","..cp.projectile[math.floor(p*6)+4].name.."|"..cp.projectile[math.floor(p*6)+4].cost..","..cp.projectile[math.floor(p*6)+5].name.."|"..cp.projectile[math.floor(p*6)+5].cost..","..cp.projectile[math.floor(p*6)+6].name.."|"..cp.projectile[math.floor(p*6)+6].cost..",,Previous,Next")
			else
				menu(id,"Set Projectile Page "..(p+1).." / "..math.ceil(#cp.projectile/6)..","..cp.projectile[math.ceil(p*6)+1].name.."|"..cp.projectile[math.floor(p*6)+1].cost..","..cp.projectile[math.floor(p*6)+2].name.."|"..cp.projectile[math.floor(p*6)+2].cost..","..cp.projectile[math.floor(p*6)+3].name.."|"..cp.projectile[math.floor(p*6)+3].cost..","..cp.projectile[math.floor(p*6)+4].name.."|"..cp.projectile[math.floor(p*6)+4].cost..","..cp.projectile[math.floor(p*6)+5].name.."|"..cp.projectile[math.floor(p*6)+5].cost..","..cp.projectile[math.floor(p*6)+6].name.."|"..cp.projectile[math.floor(p*6)+6].cost..",,Previous,Next")
			end
		end
	end
end